//+------------------------------------------------------------------+
//|                                                  Synchronous.mq5 |
//|                              Copyright  2016, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.00"
#property description "Expert synchronously plases the pending orders BuyLimit and SellLimit"
#include <Trade\Trade.mqh>
//---
CTrade   MyTrade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MyTrade.SetTypeFilling(ORDER_FILLING_RETURN);
   MyTrade.SetAsyncMode(true);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(OrdersTotal()==0)
     {
      double bid_price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
      double ask_price=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
      double tick_size=SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_SIZE);
      Comment(DoubleToString(ask_price-bid_price,Digits())," ",2*tick_size);
      if((ask_price-bid_price)<2*tick_size)
        {
         MyTrade.BuyLimit(1.0,bid_price,NULL,0.0,0.0,0,0,NULL);
         MyTrade.SellLimit(1.0,ask_price,NULL,0.0,0.0,0,0,NULL);
        }
     }
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---

  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//---

  }
//+------------------------------------------------------------------+
